︠c88abfdc-68ef-4846-bd76-4c01cb9a8dee︠
#is the graph with g6 string "DqK" in gt.sage?
︡e24989e9-d609-4a1e-913d-4306c0fd7c72︡{"done":true}︡
︠f6cf39c6-67c2-4e51-a0c6-1f60a1d52ed3︠
#to get a graph from a g6 string "DqK" use Graph("DqK")
my_graph = Graph("DqK")
my_graph.show()
︡2c682d81-871b-4801-86d7-1ac6cbae19fb︡{"file":{"filename":"/home/user/.sage/temp/project-dbc3233d-0255-496c-8503-fccd09ad7767/167927/tmp_du6LUT.svg","show":true,"text":null,"uuid":"e968e4af-f424-4b15-868e-36617e74dd98"},"once":false}︡{"done":true}︡
︠208fa748-610b-4012-b151-2cd097041d81s︠
load("gt-nb.sage")
︡d6017bbd-dbe7-4254-b8ce-dbd5e569b992︡{"stdout":"loaded utilities"}︡{"stdout":"\nloaded invariants\nloaded properties"}︡{"stdout":"\nloaded theorems\n"}︡{"stdout":"loaded graphs"}︡{"stdout":"\n\nRemember to load DIMACS and Sloane graphs if you want them\n"}︡{"done":true}︡
︠1e1f0101-114f-4e68-82ae-271c48275186︠
load("gt-nb.sage")
︡51dce0a7-95dc-4119-9cf7-0e02c195a010︡{"stdout":"loaded utilities"}︡{"stdout":"\nloaded invariants\nloaded properties"}︡{"stdout":"\nloaded theorems\n"}︡
︠a45489bd-8af6-4b74-ba7f-c49d43b561cc︠
#is my_graph already in gt.sage
len(graph_objects)
︡1f5fcc61-c512-4bbd-b124-fba4ba052a54︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1043, in execute\n    exec compile(block+'\\n', '', 'single', flags=compile_flags) in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'graph_objects' is not defined\n"}︡{"done":true}︡
︠4668dc8d-6daf-491a-8ef6-bf7e928dd56f︠
my_graph = Graph("DqK")

for g in graph_objects:
    if g.is_isomorphic(my_graph):
        print "my_graph is already there. woo-hoo!"
        break
       
#print "add my_graph to gt.sage. make this a githib issue!"
︡507481b6-8fad-43c2-81e8-15eb91847a8b︡{"stdout":"my_graph is already there. woo-hoo!\n"}︡{"done":true}︡
︠d18f3772-aca1-4fc1-ba37-23f7e32000fc︠
g = graph_objects[0]
︡2af1749f-d37f-4035-811b-dcf653ff235d︡{"done":true}︡
︠f5c473a7-ed1a-449b-83b9-f56dfe06ed58︠
g.show()
︡91b4a3be-25cf-4862-a693-2d75f76fd147︡{"file":{"filename":"/home/user/.sage/temp/project-dbc3233d-0255-496c-8503-fccd09ad7767/167927/tmp_SHrGM5.svg","show":true,"text":null,"uuid":"92904ffa-6fa4-4759-8b08-610cb6814c96"},"once":false}︡{"done":true}︡
︠7b048012-95d1-4477-bbdf-e8c7d14da565︠
g.is_isomorphic(my_graph)
︡418effc2-8dd3-4a18-a208-4ec370badf52︡{"stdout":"False\n"}︡{"done":true}︡
︠547761af-fcd3-412d-b963-a20ce58dc5b9︠
#we also want to investigate a conjecture systematically
#here's the conjecture: is_distance_regular)&(is_bipartite))->(is_hamiltonian)
#NOTE: a CE will be distance regular, bipartite and NOT hamiltonian
#search for graphs with these graphs: all graphs with some order, random graphs, graphs in gt.sage

#all graphs with order 4
#for sufficient condition conjectures, check that the graph is actually connected
for g in graphs(4,property = lambda g: g.is_connected()):
    if g.is_connected():
        if g.is_bipartite() and g.is_distance_regular() and not g.is_hamiltonian():
            print g.graph6_string()
            break
#if there's no output, there was no counterexample            
︡fad5544d-30f4-425e-8930-e17ccf46682b︡{"done":true}︡
︠bdcb5c5b-9b4e-4a38-9c4b-e2896af8583c︠
for g in graphs(8):
    if g.is_connected():
        if g.is_bipartite() and g.is_distance_regular() and not g.is_hamiltonian():
            print g.graph6_string()
            break
︡7f745eec-93cf-4e57-9999-e385d72839cb︡{"done":true}︡
︠d328d03a-6de3-4fcf-903f-f837e145e051s︠
#check the conjecture for all graphs in gt.sage with no more than n vertices (50? what's too big?)
for g in graph_objects:
    if g.is_connected() and g.order() > 2 and g.order() <= 1000:
        if g.is_bipartite() and g.is_distance_regular() and not g.is_hamiltonian():
            print g.graph6_string()
            break
︡a4653669-7937-4769-a6ad-74a1ef46d88d︡{"done":true}︡
︠a0c60107-25d5-44a6-84e4-5075dcca9bd4s︠
#now let's try neal's random graph generators
#note: we want distance-regular graphs SO neal says we should use the random regular graph generator
def rand_regular_connected(n,d):
    counter=0
    gnd = graphs.RandomRegular(d,n)
    while not gnd.is_connected():
        gnd = graphs.RandomRegular(d,n)
        counter=counter+1
        if counter==200:
            gnd=k3
    return gnd
︡ee14313b-4fab-4d0e-a3e4-4cbb2d0e6daf︡{"done":true}︡
︠83f62fcd-70bb-4087-939c-171ac73d1214︠
graphs.RandomRegular
︡3e84bfa4-a938-4685-9115-318b685b950d︡
︠234db485-f8df-4aab-8bf0-20d8c4721c2cs︠
#lets generate and test 1000 random regular graphs with order 50 and regular of degree d=10
count = 0
for i in range(1000):    
    g = rand_regular_connected(50,10)
    #print g.order(), max(g.degree())
    if g.order() > 3:
        count += 1
        if g.is_bipartite() and g.is_distance_regular() and not g.is_hamiltonian():
            print g.graph6_string()
            break
print "checked {} graphs".format(count)            
︡ade0dbc7-cd97-4f76-b47a-7d6cd89940f8︡{"stdout":"checked 1000 graphs\n"}︡{"done":true}︡
︠fa18d830-073d-45c4-8a53-25c4ff4e3be3s︠
k3 = graphs.CompleteGraph(3)
#[(is_clique)->(is_hamiltonian)] is TRUE
k3_4 = graphs.CompleteBipartiteGraph(3,4)
k5_5 = graphs.CompleteBipartiteGraph(5,5)
#(is_cycle)->(is_hamiltonian) is TRUE
k2 = graphs.CompleteGraph(2)
EH = graphs.EllinghamHorton54Graph()
#CLAIM: ((is_strongly_regular)&(is_bipartite))->(is_hamiltonian) is true for n>2
#NB presented a proof: we need to write this up!
pete = graphs.PetersenGraph()
c5 = graphs.CycleGraph(5)
fish = Graph([(0,1),(1,2),(2,3),(3,4),(4,5),(5,2),(2,0)])
c5_tail = graphs.CycleGraph(5)
#c5_tail.add_vertex()
c5_tail.add_edge(0,5)
bow_tie = Graph(5)
bow_tie.add_edges([(0,1),(1,2),(2,3),(3,4),(4,2),(2,0)])
c7 = graphs.CycleGraph(7)
c7_chord = graphs.CycleGraph(7)
c7_chord.add_edge(0,2)
glasses = Graph(7)
glasses.add_edges([(0,1),(1,2),(2,3),(3,4),(4,5),(5,6),(6,3),(3,0)])
p3 = graphs.PathGraph(3)
k5 = graphs.CompleteGraph(5)

triangle_with_tail = graphs.CompleteGraph(3)
triangle_with_tail.add_edge(0,3)
blanusa2 = graphs.BlanusaSecondSnarkGraph()
duplex = Graph("Iv?GOKFY?")
heawood = graphs.HeawoodGraph()
frucht = graphs.FruchtGraph()
nb1 = Graph("Edj_")
tutte = graphs.TutteGraph()
pete = graphs.PetersenGraph()

robertson = graphs.RobertsonGraph()
hoffman = graphs.HoffmanGraph()
folkman = graphs.FolkmanGraph()
house = graphs.HouseGraph()

subdivided_k5 = graphs.CompleteGraph(5)
subdivided_k5.subdivide_edge((0,1),1)
subdivided_k5.show()
subdivided_k5.chromatic_index()

grid_2_3=graphs.Grid2dGraph(2,3)
grid_3_3=graphs.Grid2dGraph(3,3)
grid_3_3_3 = graphs.GridGraph([3,3,3])
k_4_6 = graphs.CompleteBipartiteGraph(4,6)
k3_4_edge=graphs.CompleteBipartiteGraph(3,4)
k3_4_edge.add_edge(0,1)

current_graph_objects = [k3,pete,c5,k5_5,k3_4,EH,c7_chord,bow_tie,k5,p3,glasses,fish,c5_tail,triangle_with_tail]
current_graph_objects.append(blanusa2)
current_graph_objects.append(frucht)
current_graph_objects.append(heawood)
current_graph_objects.append(duplex)
current_graph_objects.append(nb1)
current_graph_objects.append(tutte)
current_graph_objects.append(hoffman)
current_graph_objects.append(robertson)
current_graph_objects.append(folkman)
current_graph_objects.append(house)
current_graph_objects.append(subdivided_k5)
current_graph_objects.append(gould)
current_graph_objects.append(grid_2_3)
current_graph_objects.append(grid_3_3_3)
︡4e556d9d-7e1f-4615-a2a0-215445c6c107︡{"file":{"filename":"/home/user/.sage/temp/project-dbc3233d-0255-496c-8503-fccd09ad7767/168660/tmp_1zj6_U.svg","show":true,"text":null,"uuid":"08372a8d-e54e-483e-a1c3-855aed1d64a2"},"once":false}︡{"stdout":"5\n"}︡{"done":true}︡
︠43758ef4-f551-4b25-8074-fdb6e5ef381bs︠


#conjecture: if is_ore or is_overfull implies hamiltonian
for g in current_graph_objects:
    
    print g, is_ore(g), g.is_overfull(), g.is_hamiltonian()
︡20ce5e63-8331-49d8-85ac-3312bfb7382a︡{"stdout":"Complete graph True True True\nPetersen graph False False "}︡{"stdout":"False\nCycle graph False True True\nComplete bipartite graph True False True\nComplete bipartite graph False False "}︡{"stdout":"False\nEllingham-Horton 54-graph False False "}︡{"stdout":"False\nCycle graph False False True\nGraph on 5 vertices False False False\nComplete graph True True True\nPath graph False False False\nGraph on 7 vertices False False False\nGraph on 6 vertices False False False\nCycle graph False False False\nComplete graph False False False\nBlanusa Second Snark Graph False False "}︡{"stdout":"False\nFrucht graph False False True\nHeawood graph False False True\nGraph on 10 vertices False False False\nGraph on 6 vertices False False False\nTutte Graph False False "}︡{"stdout":"False\nHoffman Graph False False True\nRobertson Graph False True True\nFolkman Graph False False True\nHouse Graph False False "}︡{"stdout":"True\nComplete graph True False True\ngould False False "}︡{"stdout":"False\n2D Grid Graph for [2, 3] False False True\nGrid Graph for [3, 3, 3] False False False\n"}︡{"done":true}︡
︠7eaac291-8cf2-4560-845f-cb51d404a253︠
J~wWGGB?wF_
︡5120f89a-0534-4623-88a6-8c67ea93c5de︡
︠19fd9782-4f94-48d1-a68c-47fa7d58686fs︠
#want a CE to ((is_ore)|(is_overfull))->(is_hamiltonian)
#need a connected graph that is either ore or overfull and not hamltonian
#check the conjecture for all graphs in gt.sage with no more than n vertices (50? what's too big?)
for g in graph_objects:
    if g.is_connected() and g.order() > 2 and g.order() <= 1000:
        if (is_ore(g) or g.is_overfull()) and not g.is_hamiltonian():
            print g.graph6_string()
            g.show()
            break
︡d66c0f63-62ff-420e-83c4-f13c1073d4bb︡{"stdout":"J~wWGGB?wF_"}︡{"stdout":"\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-dbc3233d-0255-496c-8503-fccd09ad7767/168660/tmp_xjRY8T.svg","show":true,"text":null,"uuid":"8cbfadb4-af16-4597-a62d-f2037e0bbe04"},"once":false}︡{"done":true}︡
︠bb3d5208-d5ef-4b3a-9355-e931b61673d4s︠
g=Graph("J~wWGGB?wF_")
g.show()
︡4e0813cb-3a03-4eef-ade0-7b4d6d6bb9c6︡{"file":{"filename":"/home/user/.sage/temp/project-dbc3233d-0255-496c-8503-fccd09ad7767/168660/tmp_fa_tXO.svg","show":true,"text":null,"uuid":"efac78a9-57ca-434c-b823-53b989bd8d4f"},"once":false}︡{"done":true}︡
︠ad6d45a0-b9d9-4242-84a5-7848c62d7773s︠
is_ore(g)
g.is_overfull()
g.is_hamiltonian()
︡a4644960-1138-450f-b00f-24f532d0a308︡{"stdout":"False\n"}︡{"stdout":"True\n"}︡{"stdout":"False\n"}︡{"done":true}︡
︠b96e0b5c-0fd5-4eab-90e2-621466928e38s︠
for gg in graph_objects:
    if gg.is_isomorphic(g):
        print gg.name()
︡ae039de5-8536-49c1-9b60-00921ab9ec46︡{"stdout":"throwing\n"}︡{"done":true}︡
︠401cc088-94a4-4013-9683-93e0f56d75fd︠









